


	// ttl package
const ttl = {
	// read ttl output
	get read() {
		// memoize
		delete ttl.read;
		return ttl.read = require('@graphy-dev/content.ttl.read');  // eslint-disable-line global-require
	},

	// turbo ttl output
	get turbo() {
		// memoize
		delete ttl.turbo;
		return ttl.turbo = require('@graphy-dev/content.ttl.turbo');  // eslint-disable-line global-require
	},

	// write ttl input
	get write() {
		// memoize
		delete ttl.write;
		return ttl.write = require('@graphy-dev/content.ttl.write');  // eslint-disable-line global-require
	},

	// // parse ttl input
	// parse(...a_args) {
	// 	return ttl.parser(...a_args);
	// 	// if(1 === a_args.length) {
	// 	// 	a_args[0].validate = true;
	// 	// }
	// 	// else {
	// 	// 	a_args = [
	// 	// 		a_args[0] || null,
	// 	// 		Object.assign(a_args[1] || {}, {
	// 	// 			validate: true,
	// 	// 		}),
	// 	// 	];
	// 	// }
	// 	// return ttl.deserializer(...a_args);
	// },
};	// trig package
const trig = {
	// read trig output
	get read() {
		// memoize
		delete trig.read;
		return trig.read = require('@graphy-dev/content.trig.read');  // eslint-disable-line global-require
	},

	// turbo trig output
	get turbo() {
		// memoize
		delete trig.turbo;
		return trig.turbo = require('@graphy-dev/content.trig.turbo');  // eslint-disable-line global-require
	},

	// write trig input
	get write() {
		// memoize
		delete trig.write;
		return trig.write = require('@graphy-dev/content.trig.write');  // eslint-disable-line global-require
	},

	// // parse trig input
	// parse(...a_args) {
	// 	return trig.parser(...a_args);
	// 	// if(1 === a_args.length) {
	// 	// 	a_args[0].validate = true;
	// 	// }
	// 	// else {
	// 	// 	a_args = [
	// 	// 		a_args[0] || null,
	// 	// 		Object.assign(a_args[1] || {}, {
	// 	// 			validate: true,
	// 	// 		}),
	// 	// 	];
	// 	// }
	// 	// return trig.deserializer(...a_args);
	// },
};	// nt package
const nt = {
	// read nt output
	get read() {
		// memoize
		delete nt.read;
		return nt.read = require('@graphy-dev/content.nt.read');  // eslint-disable-line global-require
	},

	// turbo nt output
	get turbo() {
		// memoize
		delete nt.turbo;
		return nt.turbo = require('@graphy-dev/content.nt.turbo');  // eslint-disable-line global-require
	},

	// write nt input
	get write() {
		// memoize
		delete nt.write;
		return nt.write = require('@graphy-dev/content.nt.write');  // eslint-disable-line global-require
	},

	// // parse nt input
	// parse(...a_args) {
	// 	return nt.parser(...a_args);
	// 	// if(1 === a_args.length) {
	// 	// 	a_args[0].validate = true;
	// 	// }
	// 	// else {
	// 	// 	a_args = [
	// 	// 		a_args[0] || null,
	// 	// 		Object.assign(a_args[1] || {}, {
	// 	// 			validate: true,
	// 	// 		}),
	// 	// 	];
	// 	// }
	// 	// return nt.deserializer(...a_args);
	// },
};	// nq package
const nq = {
	// read nq output
	get read() {
		// memoize
		delete nq.read;
		return nq.read = require('@graphy-dev/content.nq.read');  // eslint-disable-line global-require
	},

	// turbo nq output
	get turbo() {
		// memoize
		delete nq.turbo;
		return nq.turbo = require('@graphy-dev/content.nq.turbo');  // eslint-disable-line global-require
	},

	// write nq input
	get write() {
		// memoize
		delete nq.write;
		return nq.write = require('@graphy-dev/content.nq.write');  // eslint-disable-line global-require
	},

	// // parse nq input
	// parse(...a_args) {
	// 	return nq.parser(...a_args);
	// 	// if(1 === a_args.length) {
	// 	// 	a_args[0].validate = true;
	// 	// }
	// 	// else {
	// 	// 	a_args = [
	// 	// 		a_args[0] || null,
	// 	// 		Object.assign(a_args[1] || {}, {
	// 	// 			validate: true,
	// 	// 		}),
	// 	// 	];
	// 	// }
	// 	// return nq.deserializer(...a_args);
	// },
};


// // SPARQL Results package
// const sparql_results = {
// 	// deserialize sparql_results input
// 	get deserializer() {
// 		// memoize
// 		delete sparql_results.deserializer;
// 		return (sparql_results.deserializer = require('../sparql-results/deserializer.js'));
// 	},
// };


const H_MIMES = {
	'text/turtle': ttl,
	'application/trig': trig,
	'application/n-triples': nt,
	'application/n-quads': nq,
	// 'application/sparql-results+json': sparql_results,
};

const H_SPARQL_RESULT_TYPES = {
	uri: h => graphy.namedNode(h.value),
	iri: h => graphy.namedNode(h.value),
	bnode: h => graphy.blankNode(h.value),
	literal: (h) => {
		// language
		if('xml:lang' in h) {
			return graphy.literal(h.value, h['xml:lang']);
		}
		// datatype
		else if('datatype' in h) {
			return graphy.literal(h.value, graphy.namedNode(h.datatype));
		}
		// simple
		else {
			return graphy.literal(h.value);
		}
	},

	// old version of SPARQL results
	'typed-literal': h => graphy.literal(h.value, graphy.namedNode(h.datatype)),
};



const graphy = module.exports = Object.assign({

	/**
	* API:
	**/

	content: {
		ttl,
		trig,
		nt,
		nq,

	},

	// load triple data from arbitrary parser into memory
	get load() {
		// memoize
		delete graphy.load;
		return (graphy.load = require('./rdf-loader.js'));  // eslint-disable-line global-require
	},

	// //
	// get bat() {
	// 	// memoize
	// 	delete graphy.bat;
	// 	return graphy.bat = require('../bat/main.js');
	// },
	// bat: require('../bat/main.js'),

	/**
	* content types:
	**/

	ttl,
	trig,
	nt,
	nq,

	// sparql_results,
	// sparqlResults: sparql_results,

	/*
	* access to flavor by mime
	*/

	write(pm_format, ...a_args) {
		let k_format = H_MIMES[pm_format];
		if(!k_format) return null;
		let k_writer = k_format.write;
		if(a_args.length) {
			return k_writer(...a_args);
		}
		return k_writer;
	},

	read(pm_format, ...a_args) {
		let k_format = H_MIMES[pm_format];
		if(!k_format) return null;
		let k_reader = k_format.read;
		if(a_args.length) {
			return k_reader(...a_args);
		}
		return k_reader;
	},

	store: {
		memory: {
			get create() {
				delete graphy.store.memory.create;
				return (graphy.store.memory.create = require('@graphy-dev/store.memory.create'));
			},
		},
	},

	get bat() {
	// memoize
		delete graphy.bat;
		return (graphy.bat = require('@graphy-dev/bat'));
	},
	get set() {
	// memoize
		delete graphy.set;
		return (graphy.set = require('@graphy-dev/set'));
	},
	get viz() {
	// memoize
		delete graphy.viz;
		return (graphy.viz = require('@graphy-dev/viz'));
	},


	fromSPARQLResult(h_term) {
		return H_SPARQL_RESULT_TYPES[h_term.type](h_term);
	},

}, require('@graphy-dev/api.data.factory'));

// export graphy to window object if in main thread of browser
if('undefined' !== typeof window) window.graphy = graphy;
